com.amazonaws.services.simpleworkflow

## Class AbstractAmazonSimpleWorkflowAsync

- java.lang.Object
- - com.amazonaws.services.simpleworkflow.AbstractAmazonSimpleWorkflow
  - - com.amazonaws.services.simpleworkflow.AbstractAmazonSimpleWorkflowAsync

All Implemented Interfaces:
  AmazonSimpleWorkflow, AmazonSimpleWorkflowAsync

    public class AbstractAmazonSimpleWorkflowAsync
    extends AbstractAmazonSimpleWorkflow
    implements AmazonSimpleWorkflowAsync

Abstract implementation of `AmazonSimpleWorkflowAsync`. Convenient method forms pass through to the corresponding overload that takes a request object and an `AsyncHandler`, which throws an `UnsupportedOperationException`.

### Field Summary

### Fields inherited from interface com.amazonaws.services.simpleworkflow.AmazonSimpleWorkflow

`ENDPOINT_PREFIX`

### Constructor Summary

Constructors
`protected` `AbstractAmazonSimpleWorkflowAsync()`

### Method Summary

All Methods Instance Methods Concrete Methods
`Future<WorkflowExecutionCount>` `countClosedWorkflowExecutionsAsync(CountClosedWorkflowExecutionsRequest request)` Returns the number of closed workflow executions within the given domain that meet the specified filtering criteria.
`Future<WorkflowExecutionCount>` `countClosedWorkflowExecutionsAsync(CountClosedWorkflowExecutionsRequest request, AsyncHandler<CountClosedWorkflowExecutionsRequest,WorkflowExecutionCount> asyncHandler)` Returns the number of closed workflow executions within the given domain that meet the specified filtering criteria.
`Future<WorkflowExecutionCount>` `countOpenWorkflowExecutionsAsync(CountOpenWorkflowExecutionsRequest request)` Returns the number of open workflow executions within the given domain that meet the specified filtering criteria.
`Future<WorkflowExecutionCount>` `countOpenWorkflowExecutionsAsync(CountOpenWorkflowExecutionsRequest request, AsyncHandler<CountOpenWorkflowExecutionsRequest,WorkflowExecutionCount> asyncHandler)` Returns the number of open workflow executions within the given domain that meet the specified filtering criteria.
`Future<PendingTaskCount>` `countPendingActivityTasksAsync(CountPendingActivityTasksRequest request)` Returns the estimated number of activity tasks in the specified task list.
`Future<PendingTaskCount>` `countPendingActivityTasksAsync(CountPendingActivityTasksRequest request, AsyncHandler<CountPendingActivityTasksRequest,PendingTaskCount> asyncHandler)` Returns the estimated number of activity tasks in the specified task list.
`Future<PendingTaskCount>` `countPendingDecisionTasksAsync(CountPendingDecisionTasksRequest request)` Returns the estimated number of decision tasks in the specified task list.
`Future<PendingTaskCount>` `countPendingDecisionTasksAsync(CountPendingDecisionTasksRequest request, AsyncHandler<CountPendingDecisionTasksRequest,PendingTaskCount> asyncHandler)` Returns the estimated number of decision tasks in the specified task list.
`Future<Void>` `deprecateActivityTypeAsync(DeprecateActivityTypeRequest request)` Deprecates the specified activity type.
`Future<Void>` `deprecateActivityTypeAsync(DeprecateActivityTypeRequest request, AsyncHandler<DeprecateActivityTypeRequest,Void> asyncHandler)` Deprecates the specified activity type.
`Future<Void>` `deprecateDomainAsync(DeprecateDomainRequest request)` Deprecates the specified domain.
`Future<Void>` `deprecateDomainAsync(DeprecateDomainRequest request, AsyncHandler<DeprecateDomainRequest,Void> asyncHandler)` Deprecates the specified domain.
`Future<Void>` `deprecateWorkflowTypeAsync(DeprecateWorkflowTypeRequest request)` Deprecates the specified workflow type.
`Future<Void>` `deprecateWorkflowTypeAsync(DeprecateWorkflowTypeRequest request, AsyncHandler<DeprecateWorkflowTypeRequest,Void> asyncHandler)` Deprecates the specified workflow type.
`Future<ActivityTypeDetail>` `describeActivityTypeAsync(DescribeActivityTypeRequest request)` Returns information about the specified activity type.
`Future<ActivityTypeDetail>` `describeActivityTypeAsync(DescribeActivityTypeRequest request, AsyncHandler<DescribeActivityTypeRequest,ActivityTypeDetail> asyncHandler)` Returns information about the specified activity type.
`Future<DomainDetail>` `describeDomainAsync(DescribeDomainRequest request)` Returns information about the specified domain, including description and status.
`Future<DomainDetail>` `describeDomainAsync(DescribeDomainRequest request, AsyncHandler<DescribeDomainRequest,DomainDetail> asyncHandler)` Returns information about the specified domain, including description and status.
`Future<WorkflowExecutionDetail>` `describeWorkflowExecutionAsync(DescribeWorkflowExecutionRequest request)` Returns information about the specified workflow execution including its type and some statistics.
`Future<WorkflowExecutionDetail>` `describeWorkflowExecutionAsync(DescribeWorkflowExecutionRequest request, AsyncHandler<DescribeWorkflowExecutionRequest,WorkflowExecutionDetail> asyncHandler)` Returns information about the specified workflow execution including its type and some statistics.
`Future<WorkflowTypeDetail>` `describeWorkflowTypeAsync(DescribeWorkflowTypeRequest request)` Returns information about the specified workflow type.
`Future<WorkflowTypeDetail>` `describeWorkflowTypeAsync(DescribeWorkflowTypeRequest request, AsyncHandler<DescribeWorkflowTypeRequest,WorkflowTypeDetail> asyncHandler)` Returns information about the specified workflow type.
`Future<History>` `getWorkflowExecutionHistoryAsync(GetWorkflowExecutionHistoryRequest request)` Returns the history of the specified workflow execution.
`Future<History>` `getWorkflowExecutionHistoryAsync(GetWorkflowExecutionHistoryRequest request, AsyncHandler<GetWorkflowExecutionHistoryRequest,History> asyncHandler)` Returns the history of the specified workflow execution.
`Future<ActivityTypeInfos>` `listActivityTypesAsync(ListActivityTypesRequest request)` Returns information about all activities registered in the specified domain that match the specified name and registration status.
`Future<ActivityTypeInfos>` `listActivityTypesAsync(ListActivityTypesRequest request, AsyncHandler<ListActivityTypesRequest,ActivityTypeInfos> asyncHandler)` Returns information about all activities registered in the specified domain that match the specified name and registration status.
`Future<WorkflowExecutionInfos>` `listClosedWorkflowExecutionsAsync(ListClosedWorkflowExecutionsRequest request)` Returns a list of closed workflow executions in the specified domain that meet the filtering criteria.
`Future<WorkflowExecutionInfos>` `listClosedWorkflowExecutionsAsync(ListClosedWorkflowExecutionsRequest request, AsyncHandler<ListClosedWorkflowExecutionsRequest,WorkflowExecutionInfos> asyncHandler)` Returns a list of closed workflow executions in the specified domain that meet the filtering criteria.
`Future<DomainInfos>` `listDomainsAsync(ListDomainsRequest request)` Returns the list of domains registered in the account.
`Future<DomainInfos>` `listDomainsAsync(ListDomainsRequest request, AsyncHandler<ListDomainsRequest,DomainInfos> asyncHandler)` Returns the list of domains registered in the account.
`Future<WorkflowExecutionInfos>` `listOpenWorkflowExecutionsAsync(ListOpenWorkflowExecutionsRequest request)` Returns a list of open workflow executions in the specified domain that meet the filtering criteria.
`Future<WorkflowExecutionInfos>` `listOpenWorkflowExecutionsAsync(ListOpenWorkflowExecutionsRequest request, AsyncHandler<ListOpenWorkflowExecutionsRequest,WorkflowExecutionInfos> asyncHandler)` Returns a list of open workflow executions in the specified domain that meet the filtering criteria.
`Future<WorkflowTypeInfos>` `listWorkflowTypesAsync(ListWorkflowTypesRequest request)` Returns information about workflow types in the specified domain.
`Future<WorkflowTypeInfos>` `listWorkflowTypesAsync(ListWorkflowTypesRequest request, AsyncHandler<ListWorkflowTypesRequest,WorkflowTypeInfos> asyncHandler)` Returns information about workflow types in the specified domain.
`Future<ActivityTask>` `pollForActivityTaskAsync(PollForActivityTaskRequest request)` Used by workers to get an ActivityTask from the specified activity `taskList`.
`Future<ActivityTask>` `pollForActivityTaskAsync(PollForActivityTaskRequest request, AsyncHandler<PollForActivityTaskRequest,ActivityTask> asyncHandler)` Used by workers to get an ActivityTask from the specified activity `taskList`.
`Future<DecisionTask>` `pollForDecisionTaskAsync(PollForDecisionTaskRequest request)` Used by deciders to get a DecisionTask from the specified decision `taskList`.
`Future<DecisionTask>` `pollForDecisionTaskAsync(PollForDecisionTaskRequest request, AsyncHandler<PollForDecisionTaskRequest,DecisionTask> asyncHandler)` Used by deciders to get a DecisionTask from the specified decision `taskList`.
`Future<ActivityTaskStatus>` `recordActivityTaskHeartbeatAsync(RecordActivityTaskHeartbeatRequest request)` Used by activity workers to report to the service that the ActivityTask represented by the specified `taskToken` is still making progress.
`Future<ActivityTaskStatus>` `recordActivityTaskHeartbeatAsync(RecordActivityTaskHeartbeatRequest request, AsyncHandler<RecordActivityTaskHeartbeatRequest,ActivityTaskStatus> asyncHandler)` Used by activity workers to report to the service that the ActivityTask represented by the specified `taskToken` is still making progress.
`Future<Void>` `registerActivityTypeAsync(RegisterActivityTypeRequest request)` Registers a new activity type along with its configuration settings in the specified domain.
`Future<Void>` `registerActivityTypeAsync(RegisterActivityTypeRequest request, AsyncHandler<RegisterActivityTypeRequest,Void> asyncHandler)` Registers a new activity type along with its configuration settings in the specified domain.
`Future<Void>` `registerDomainAsync(RegisterDomainRequest request)` Registers a new domain.
`Future<Void>` `registerDomainAsync(RegisterDomainRequest request, AsyncHandler<RegisterDomainRequest,Void> asyncHandler)` Registers a new domain.
`Future<Void>` `registerWorkflowTypeAsync(RegisterWorkflowTypeRequest request)` Registers a new workflow type and its configuration settings in the specified domain.
`Future<Void>` `registerWorkflowTypeAsync(RegisterWorkflowTypeRequest request, AsyncHandler<RegisterWorkflowTypeRequest,Void> asyncHandler)` Registers a new workflow type and its configuration settings in the specified domain.
`Future<Void>` `requestCancelWorkflowExecutionAsync(RequestCancelWorkflowExecutionRequest request)` Records a `WorkflowExecutionCancelRequested` event in the currently running workflow execution identified by the given domain, workflowId, and runId.
`Future<Void>` `requestCancelWorkflowExecutionAsync(RequestCancelWorkflowExecutionRequest request, AsyncHandler<RequestCancelWorkflowExecutionRequest,Void> asyncHandler)` Records a `WorkflowExecutionCancelRequested` event in the currently running workflow execution identified by the given domain, workflowId, and runId.
`Future<Void>` `respondActivityTaskCanceledAsync(RespondActivityTaskCanceledRequest request)` Used by workers to tell the service that the ActivityTask identified by the `taskToken` was successfully canceled.
`Future<Void>` `respondActivityTaskCanceledAsync(RespondActivityTaskCanceledRequest request, AsyncHandler<RespondActivityTaskCanceledRequest,Void> asyncHandler)` Used by workers to tell the service that the ActivityTask identified by the `taskToken` was successfully canceled.
`Future<Void>` `respondActivityTaskCompletedAsync(RespondActivityTaskCompletedRequest request)` Used by workers to tell the service that the ActivityTask identified by the `taskToken` completed successfully with a `result` (if provided).
`Future<Void>` `respondActivityTaskCompletedAsync(RespondActivityTaskCompletedRequest request, AsyncHandler<RespondActivityTaskCompletedRequest,Void> asyncHandler)` Used by workers to tell the service that the ActivityTask identified by the `taskToken` completed successfully with a `result` (if provided).
`Future<Void>` `respondActivityTaskFailedAsync(RespondActivityTaskFailedRequest request)` Used by workers to tell the service that the ActivityTask identified by the `taskToken` has failed with `reason` (if specified).
`Future<Void>` `respondActivityTaskFailedAsync(RespondActivityTaskFailedRequest request, AsyncHandler<RespondActivityTaskFailedRequest,Void> asyncHandler)` Used by workers to tell the service that the ActivityTask identified by the `taskToken` has failed with `reason` (if specified).
`Future<Void>` `respondDecisionTaskCompletedAsync(RespondDecisionTaskCompletedRequest request)` Used by deciders to tell the service that the DecisionTask identified by the `taskToken` has successfully completed.
`Future<Void>` `respondDecisionTaskCompletedAsync(RespondDecisionTaskCompletedRequest request, AsyncHandler<RespondDecisionTaskCompletedRequest,Void> asyncHandler)` Used by deciders to tell the service that the DecisionTask identified by the `taskToken` has successfully completed.
`Future<Void>` `signalWorkflowExecutionAsync(SignalWorkflowExecutionRequest request)` Records a `WorkflowExecutionSignaled` event in the workflow execution history and creates a decision task for the workflow execution identified by the given domain, workflowId and runId.
`Future<Void>` `signalWorkflowExecutionAsync(SignalWorkflowExecutionRequest request, AsyncHandler<SignalWorkflowExecutionRequest,Void> asyncHandler)` Records a `WorkflowExecutionSignaled` event in the workflow execution history and creates a decision task for the workflow execution identified by the given domain, workflowId and runId.
`Future<Run>` `startWorkflowExecutionAsync(StartWorkflowExecutionRequest request)` Starts an execution of the workflow type in the specified domain using the provided `workflowId` and input data.
`Future<Run>` `startWorkflowExecutionAsync(StartWorkflowExecutionRequest request, AsyncHandler<StartWorkflowExecutionRequest,Run> asyncHandler)` Starts an execution of the workflow type in the specified domain using the provided `workflowId` and input data.
`Future<Void>` `terminateWorkflowExecutionAsync(TerminateWorkflowExecutionRequest request)` Records a `WorkflowExecutionTerminated` event and forces closure of the workflow execution identified by the given domain, runId, and workflowId.
`Future<Void>` `terminateWorkflowExecutionAsync(TerminateWorkflowExecutionRequest request, AsyncHandler<TerminateWorkflowExecutionRequest,Void> asyncHandler)` Records a `WorkflowExecutionTerminated` event and forces closure of the workflow execution identified by the given domain, runId, and workflowId.

### Methods inherited from class com.amazonaws.services.simpleworkflow.AbstractAmazonSimpleWorkflow

`countClosedWorkflowExecutions, countOpenWorkflowExecutions, countPendingActivityTasks, countPendingDecisionTasks, deprecateActivityType, deprecateDomain, deprecateWorkflowType, describeActivityType, describeDomain, describeWorkflowExecution, describeWorkflowType, getCachedResponseMetadata, getWorkflowExecutionHistory, listActivityTypes, listClosedWorkflowExecutions, listDomains, listOpenWorkflowExecutions, listWorkflowTypes, pollForActivityTask, pollForDecisionTask, recordActivityTaskHeartbeat, registerActivityType, registerDomain, registerWorkflowType, requestCancelWorkflowExecution, respondActivityTaskCanceled, respondActivityTaskCompleted, respondActivityTaskFailed, respondDecisionTaskCompleted, setEndpoint, setRegion, shutdown, signalWorkflowExecution, startWorkflowExecution, terminateWorkflowExecution`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface com.amazonaws.services.simpleworkflow.AmazonSimpleWorkflow

`countClosedWorkflowExecutions, countOpenWorkflowExecutions, countPendingActivityTasks, countPendingDecisionTasks, deprecateActivityType, deprecateDomain, deprecateWorkflowType, describeActivityType, describeDomain, describeWorkflowExecution, describeWorkflowType, getCachedResponseMetadata, getWorkflowExecutionHistory, listActivityTypes, listClosedWorkflowExecutions, listDomains, listOpenWorkflowExecutions, listWorkflowTypes, pollForActivityTask, pollForDecisionTask, recordActivityTaskHeartbeat, registerActivityType, registerDomain, registerWorkflowType, requestCancelWorkflowExecution, respondActivityTaskCanceled, respondActivityTaskCompleted, respondActivityTaskFailed, respondDecisionTaskCompleted, setEndpoint, setRegion, shutdown, signalWorkflowExecution, startWorkflowExecution, terminateWorkflowExecution`

### Constructor Detail

#### AbstractAmazonSimpleWorkflowAsync

    protected AbstractAmazonSimpleWorkflowAsync()

### Method Detail

#### countClosedWorkflowExecutionsAsync

    public Future<WorkflowExecutionCount> countClosedWorkflowExecutionsAsync(CountClosedWorkflowExecutionsRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the number of closed workflow executions within the given domain that meet the specified filtering criteria.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `tagFilter.tag`: String constraint. The key is `swf:tagFilter.tag`.
  - `typeFilter.name`: String constraint. The key is `swf:typeFilter.name`.
  - `typeFilter.version`: String constraint. The key is `swf:typeFilter.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `countClosedWorkflowExecutionsAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the CountClosedWorkflowExecutions operation returned by the service.

#### countClosedWorkflowExecutionsAsync

    public Future<WorkflowExecutionCount> countClosedWorkflowExecutionsAsync(CountClosedWorkflowExecutionsRequest request,
                                                                             AsyncHandler<CountClosedWorkflowExecutionsRequest,WorkflowExecutionCount> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the number of closed workflow executions within the given domain that meet the specified filtering criteria.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `tagFilter.tag`: String constraint. The key is `swf:tagFilter.tag`.
  - `typeFilter.name`: String constraint. The key is `swf:typeFilter.name`.
  - `typeFilter.version`: String constraint. The key is `swf:typeFilter.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `countClosedWorkflowExecutionsAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the CountClosedWorkflowExecutions operation returned by the service.

#### countOpenWorkflowExecutionsAsync

    public Future<WorkflowExecutionCount> countOpenWorkflowExecutionsAsync(CountOpenWorkflowExecutionsRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the number of open workflow executions within the given domain that meet the specified filtering criteria.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `tagFilter.tag`: String constraint. The key is `swf:tagFilter.tag`.
  - `typeFilter.name`: String constraint. The key is `swf:typeFilter.name`.
  - `typeFilter.version`: String constraint. The key is `swf:typeFilter.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `countOpenWorkflowExecutionsAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the CountOpenWorkflowExecutions operation returned by the service.

#### countOpenWorkflowExecutionsAsync

    public Future<WorkflowExecutionCount> countOpenWorkflowExecutionsAsync(CountOpenWorkflowExecutionsRequest request,
                                                                           AsyncHandler<CountOpenWorkflowExecutionsRequest,WorkflowExecutionCount> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the number of open workflow executions within the given domain that meet the specified filtering criteria.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `tagFilter.tag`: String constraint. The key is `swf:tagFilter.tag`.
  - `typeFilter.name`: String constraint. The key is `swf:typeFilter.name`.
  - `typeFilter.version`: String constraint. The key is `swf:typeFilter.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `countOpenWorkflowExecutionsAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the CountOpenWorkflowExecutions operation returned by the service.

#### countPendingActivityTasksAsync

    public Future<PendingTaskCount> countPendingActivityTasksAsync(CountPendingActivityTasksRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the estimated number of activity tasks in the specified task list. The count returned is an approximation and is not guaranteed to be exact. If you specify a task list that no activity task was ever scheduled in then 0 will be returned.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the `taskList.name` parameter by using a Condition element with the `swf:taskList.name` key to allow the action to access only certain task lists.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `countPendingActivityTasksAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the CountPendingActivityTasks operation returned by the service.

#### countPendingActivityTasksAsync

    public Future<PendingTaskCount> countPendingActivityTasksAsync(CountPendingActivityTasksRequest request,
                                                                   AsyncHandler<CountPendingActivityTasksRequest,PendingTaskCount> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the estimated number of activity tasks in the specified task list. The count returned is an approximation and is not guaranteed to be exact. If you specify a task list that no activity task was ever scheduled in then 0 will be returned.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the `taskList.name` parameter by using a Condition element with the `swf:taskList.name` key to allow the action to access only certain task lists.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `countPendingActivityTasksAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the CountPendingActivityTasks operation returned by the service.

#### countPendingDecisionTasksAsync

    public Future<PendingTaskCount> countPendingDecisionTasksAsync(CountPendingDecisionTasksRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the estimated number of decision tasks in the specified task list. The count returned is an approximation and is not guaranteed to be exact. If you specify a task list that no decision task was ever scheduled in then 0 will be returned.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the `taskList.name` parameter by using a Condition element with the `swf:taskList.name` key to allow the action to access only certain task lists.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `countPendingDecisionTasksAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the CountPendingDecisionTasks operation returned by the service.

#### countPendingDecisionTasksAsync

    public Future<PendingTaskCount> countPendingDecisionTasksAsync(CountPendingDecisionTasksRequest request,
                                                                   AsyncHandler<CountPendingDecisionTasksRequest,PendingTaskCount> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the estimated number of decision tasks in the specified task list. The count returned is an approximation and is not guaranteed to be exact. If you specify a task list that no decision task was ever scheduled in then 0 will be returned.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the `taskList.name` parameter by using a Condition element with the `swf:taskList.name` key to allow the action to access only certain task lists.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `countPendingDecisionTasksAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the CountPendingDecisionTasks operation returned by the service.

#### deprecateActivityTypeAsync

    public Future<Void> deprecateActivityTypeAsync(DeprecateActivityTypeRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Deprecates the specified activity type. After an activity type has been deprecated, you cannot create new tasks of that activity type. Tasks of this type that were scheduled before the type was deprecated will continue to run.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `activityType.name`: String constraint. The key is `swf:activityType.name`.
  - `activityType.version`: String constraint. The key is `swf:activityType.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `deprecateActivityTypeAsync` in interface `AmazonSimpleWorkflowAsync`

#### deprecateActivityTypeAsync

    public Future<Void> deprecateActivityTypeAsync(DeprecateActivityTypeRequest request,
                                                   AsyncHandler<DeprecateActivityTypeRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Deprecates the specified activity type. After an activity type has been deprecated, you cannot create new tasks of that activity type. Tasks of this type that were scheduled before the type was deprecated will continue to run.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `activityType.name`: String constraint. The key is `swf:activityType.name`.
  - `activityType.version`: String constraint. The key is `swf:activityType.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `deprecateActivityTypeAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### deprecateDomainAsync

    public Future<Void> deprecateDomainAsync(DeprecateDomainRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Deprecates the specified domain. After a domain has been deprecated it cannot be used to create new workflow executions or register new types. However, you can still use visibility actions on this domain. Deprecating a domain also deprecates all activity and workflow types registered in the domain. Executions that were started before the domain was deprecated will continue to run.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `deprecateDomainAsync` in interface `AmazonSimpleWorkflowAsync`

#### deprecateDomainAsync

    public Future<Void> deprecateDomainAsync(DeprecateDomainRequest request,
                                             AsyncHandler<DeprecateDomainRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Deprecates the specified domain. After a domain has been deprecated it cannot be used to create new workflow executions or register new types. However, you can still use visibility actions on this domain. Deprecating a domain also deprecates all activity and workflow types registered in the domain. Executions that were started before the domain was deprecated will continue to run.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `deprecateDomainAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### deprecateWorkflowTypeAsync

    public Future<Void> deprecateWorkflowTypeAsync(DeprecateWorkflowTypeRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Deprecates the specified workflow type. After a workflow type has been deprecated, you cannot create new executions of that type. Executions that were started before the type was deprecated will continue to run. A deprecated workflow type may still be used when calling visibility actions.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `workflowType.name`: String constraint. The key is `swf:workflowType.name`.
  - `workflowType.version`: String constraint. The key is `swf:workflowType.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `deprecateWorkflowTypeAsync` in interface `AmazonSimpleWorkflowAsync`

#### deprecateWorkflowTypeAsync

    public Future<Void> deprecateWorkflowTypeAsync(DeprecateWorkflowTypeRequest request,
                                                   AsyncHandler<DeprecateWorkflowTypeRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Deprecates the specified workflow type. After a workflow type has been deprecated, you cannot create new executions of that type. Executions that were started before the type was deprecated will continue to run. A deprecated workflow type may still be used when calling visibility actions.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `workflowType.name`: String constraint. The key is `swf:workflowType.name`.
  - `workflowType.version`: String constraint. The key is `swf:workflowType.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `deprecateWorkflowTypeAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### describeActivityTypeAsync

    public Future<ActivityTypeDetail> describeActivityTypeAsync(DescribeActivityTypeRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about the specified activity type. This includes configuration settings provided when the type was registered and other general information about the type.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `activityType.name`: String constraint. The key is `swf:activityType.name`.
  - `activityType.version`: String constraint. The key is `swf:activityType.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `describeActivityTypeAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the DescribeActivityType operation returned by the service.

#### describeActivityTypeAsync

    public Future<ActivityTypeDetail> describeActivityTypeAsync(DescribeActivityTypeRequest request,
                                                                AsyncHandler<DescribeActivityTypeRequest,ActivityTypeDetail> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about the specified activity type. This includes configuration settings provided when the type was registered and other general information about the type.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `activityType.name`: String constraint. The key is `swf:activityType.name`.
  - `activityType.version`: String constraint. The key is `swf:activityType.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `describeActivityTypeAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DescribeActivityType operation returned by the service.

#### describeDomainAsync

    public Future<DomainDetail> describeDomainAsync(DescribeDomainRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about the specified domain, including description and status.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `describeDomainAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the DescribeDomain operation returned by the service.

#### describeDomainAsync

    public Future<DomainDetail> describeDomainAsync(DescribeDomainRequest request,
                                                    AsyncHandler<DescribeDomainRequest,DomainDetail> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about the specified domain, including description and status.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `describeDomainAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DescribeDomain operation returned by the service.

#### describeWorkflowExecutionAsync

    public Future<WorkflowExecutionDetail> describeWorkflowExecutionAsync(DescribeWorkflowExecutionRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about the specified workflow execution including its type and some statistics.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `describeWorkflowExecutionAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the DescribeWorkflowExecution operation returned by the service.

#### describeWorkflowExecutionAsync

    public Future<WorkflowExecutionDetail> describeWorkflowExecutionAsync(DescribeWorkflowExecutionRequest request,
                                                                          AsyncHandler<DescribeWorkflowExecutionRequest,WorkflowExecutionDetail> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about the specified workflow execution including its type and some statistics.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `describeWorkflowExecutionAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DescribeWorkflowExecution operation returned by the service.

#### describeWorkflowTypeAsync

    public Future<WorkflowTypeDetail> describeWorkflowTypeAsync(DescribeWorkflowTypeRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about the specified workflow type. This includes configuration settings specified when the type was registered and other information such as creation date, current status, and so on.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `workflowType.name`: String constraint. The key is `swf:workflowType.name`.
  - `workflowType.version`: String constraint. The key is `swf:workflowType.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `describeWorkflowTypeAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the DescribeWorkflowType operation returned by the service.

#### describeWorkflowTypeAsync

    public Future<WorkflowTypeDetail> describeWorkflowTypeAsync(DescribeWorkflowTypeRequest request,
                                                                AsyncHandler<DescribeWorkflowTypeRequest,WorkflowTypeDetail> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about the specified workflow type. This includes configuration settings specified when the type was registered and other information such as creation date, current status, and so on.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `workflowType.name`: String constraint. The key is `swf:workflowType.name`.
  - `workflowType.version`: String constraint. The key is `swf:workflowType.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `describeWorkflowTypeAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DescribeWorkflowType operation returned by the service.

#### getWorkflowExecutionHistoryAsync

    public Future<History> getWorkflowExecutionHistoryAsync(GetWorkflowExecutionHistoryRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the history of the specified workflow execution. The results may be split into multiple pages. To retrieve subsequent pages, make the call again using the `nextPageToken` returned by the initial call.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `getWorkflowExecutionHistoryAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the GetWorkflowExecutionHistory operation returned by the service.

#### getWorkflowExecutionHistoryAsync

    public Future<History> getWorkflowExecutionHistoryAsync(GetWorkflowExecutionHistoryRequest request,
                                                            AsyncHandler<GetWorkflowExecutionHistoryRequest,History> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the history of the specified workflow execution. The results may be split into multiple pages. To retrieve subsequent pages, make the call again using the `nextPageToken` returned by the initial call.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `getWorkflowExecutionHistoryAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the GetWorkflowExecutionHistory operation returned by the service.

#### listActivityTypesAsync

    public Future<ActivityTypeInfos> listActivityTypesAsync(ListActivityTypesRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about all activities registered in the specified domain that match the specified name and registration status. The result includes information like creation date, current status of the activity, etc. The results may be split into multiple pages. To retrieve subsequent pages, make the call again using the `nextPageToken` returned by the initial call.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `listActivityTypesAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the ListActivityTypes operation returned by the service.

#### listActivityTypesAsync

    public Future<ActivityTypeInfos> listActivityTypesAsync(ListActivityTypesRequest request,
                                                            AsyncHandler<ListActivityTypesRequest,ActivityTypeInfos> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about all activities registered in the specified domain that match the specified name and registration status. The result includes information like creation date, current status of the activity, etc. The results may be split into multiple pages. To retrieve subsequent pages, make the call again using the `nextPageToken` returned by the initial call.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `listActivityTypesAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the ListActivityTypes operation returned by the service.

#### listClosedWorkflowExecutionsAsync

    public Future<WorkflowExecutionInfos> listClosedWorkflowExecutionsAsync(ListClosedWorkflowExecutionsRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns a list of closed workflow executions in the specified domain that meet the filtering criteria. The results may be split into multiple pages. To retrieve subsequent pages, make the call again using the nextPageToken returned by the initial call.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `tagFilter.tag`: String constraint. The key is `swf:tagFilter.tag`.
  - `typeFilter.name`: String constraint. The key is `swf:typeFilter.name`.
  - `typeFilter.version`: String constraint. The key is `swf:typeFilter.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `listClosedWorkflowExecutionsAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the ListClosedWorkflowExecutions operation returned by the service.

#### listClosedWorkflowExecutionsAsync

    public Future<WorkflowExecutionInfos> listClosedWorkflowExecutionsAsync(ListClosedWorkflowExecutionsRequest request,
                                                                            AsyncHandler<ListClosedWorkflowExecutionsRequest,WorkflowExecutionInfos> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns a list of closed workflow executions in the specified domain that meet the filtering criteria. The results may be split into multiple pages. To retrieve subsequent pages, make the call again using the nextPageToken returned by the initial call.

<note>This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `tagFilter.tag`: String constraint. The key is `swf:tagFilter.tag`.
  - `typeFilter.name`: String constraint. The key is `swf:typeFilter.name`.
  - `typeFilter.version`: String constraint. The key is `swf:typeFilter.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `listClosedWorkflowExecutionsAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the ListClosedWorkflowExecutions operation returned by the service.

#### listDomainsAsync

    public Future<DomainInfos> listDomainsAsync(ListDomainsRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the list of domains registered in the account. The results may be split into multiple pages. To retrieve subsequent pages, make the call again using the nextPageToken returned by the initial call.

<note> This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains. The element must be set to `arn:aws:swf::AccountID:domain/*`, where AccountID is the account ID, with no dashes.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `listDomainsAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the ListDomains operation returned by the service.

#### listDomainsAsync

    public Future<DomainInfos> listDomainsAsync(ListDomainsRequest request,
                                                AsyncHandler<ListDomainsRequest,DomainInfos> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns the list of domains registered in the account. The results may be split into multiple pages. To retrieve subsequent pages, make the call again using the nextPageToken returned by the initial call.

<note> This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains. The element must be set to `arn:aws:swf::AccountID:domain/*`, where AccountID is the account ID, with no dashes.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `listDomainsAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the ListDomains operation returned by the service.

#### listOpenWorkflowExecutionsAsync

    public Future<WorkflowExecutionInfos> listOpenWorkflowExecutionsAsync(ListOpenWorkflowExecutionsRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns a list of open workflow executions in the specified domain that meet the filtering criteria. The results may be split into multiple pages. To retrieve subsequent pages, make the call again using the nextPageToken returned by the initial call.

<note> This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `tagFilter.tag`: String constraint. The key is `swf:tagFilter.tag`.
  - `typeFilter.name`: String constraint. The key is `swf:typeFilter.name`.
  - `typeFilter.version`: String constraint. The key is `swf:typeFilter.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `listOpenWorkflowExecutionsAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the ListOpenWorkflowExecutions operation returned by the service.

#### listOpenWorkflowExecutionsAsync

    public Future<WorkflowExecutionInfos> listOpenWorkflowExecutionsAsync(ListOpenWorkflowExecutionsRequest request,
                                                                          AsyncHandler<ListOpenWorkflowExecutionsRequest,WorkflowExecutionInfos> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns a list of open workflow executions in the specified domain that meet the filtering criteria. The results may be split into multiple pages. To retrieve subsequent pages, make the call again using the nextPageToken returned by the initial call.

<note> This operation is eventually consistent. The results are best effort and may not exactly reflect recent updates and changes.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `tagFilter.tag`: String constraint. The key is `swf:tagFilter.tag`.
  - `typeFilter.name`: String constraint. The key is `swf:typeFilter.name`.
  - `typeFilter.version`: String constraint. The key is `swf:typeFilter.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `listOpenWorkflowExecutionsAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the ListOpenWorkflowExecutions operation returned by the service.

#### listWorkflowTypesAsync

    public Future<WorkflowTypeInfos> listWorkflowTypesAsync(ListWorkflowTypesRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about workflow types in the specified domain. The results may be split into multiple pages that can be retrieved by making the call repeatedly.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `listWorkflowTypesAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the ListWorkflowTypes operation returned by the service.

#### listWorkflowTypesAsync

    public Future<WorkflowTypeInfos> listWorkflowTypesAsync(ListWorkflowTypesRequest request,
                                                            AsyncHandler<ListWorkflowTypesRequest,WorkflowTypeInfos> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Returns information about workflow types in the specified domain. The results may be split into multiple pages that can be retrieved by making the call repeatedly.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `listWorkflowTypesAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the ListWorkflowTypes operation returned by the service.

#### pollForActivityTaskAsync

    public Future<ActivityTask> pollForActivityTaskAsync(PollForActivityTaskRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by workers to get an ActivityTask from the specified activity `taskList`. This initiates a long poll, where the service holds the HTTP connection open and responds as soon as a task becomes available. The maximum time the service holds on to the request before responding is 60 seconds. If no task is available within 60 seconds, the poll will return an empty result. An empty result, in this context, means that an ActivityTask is returned, but that the value of taskToken is an empty string. If a task is returned, the worker should use its type to identify and process it correctly.

<important>Workers should set their client side socket timeout to at least 70 seconds (10 seconds higher than the maximum time service may hold the poll request).</important>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the `taskList.name` parameter by using a Condition element with the `swf:taskList.name` key to allow the action to access only certain task lists.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `pollForActivityTaskAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the PollForActivityTask operation returned by the service.

#### pollForActivityTaskAsync

    public Future<ActivityTask> pollForActivityTaskAsync(PollForActivityTaskRequest request,
                                                         AsyncHandler<PollForActivityTaskRequest,ActivityTask> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by workers to get an ActivityTask from the specified activity `taskList`. This initiates a long poll, where the service holds the HTTP connection open and responds as soon as a task becomes available. The maximum time the service holds on to the request before responding is 60 seconds. If no task is available within 60 seconds, the poll will return an empty result. An empty result, in this context, means that an ActivityTask is returned, but that the value of taskToken is an empty string. If a task is returned, the worker should use its type to identify and process it correctly.

<important>Workers should set their client side socket timeout to at least 70 seconds (10 seconds higher than the maximum time service may hold the poll request).</important>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the `taskList.name` parameter by using a Condition element with the `swf:taskList.name` key to allow the action to access only certain task lists.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `pollForActivityTaskAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the PollForActivityTask operation returned by the service.

#### pollForDecisionTaskAsync

    public Future<DecisionTask> pollForDecisionTaskAsync(PollForDecisionTaskRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by deciders to get a DecisionTask from the specified decision `taskList`. A decision task may be returned for any open workflow execution that is using the specified task list. The task includes a paginated view of the history of the workflow execution. The decider should use the workflow type and the history to determine how to properly handle the task.

This action initiates a long poll, where the service holds the HTTP connection open and responds as soon a task becomes available. If no decision task is available in the specified task list before the timeout of 60 seconds expires, an empty result is returned. An empty result, in this context, means that a DecisionTask is returned, but that the value of `taskToken` is an empty string.

<important>Deciders should set their client-side socket timeout to at least 70 seconds (10 seconds higher than the timeout).</important> <important>Because the number of workflow history events for a single workflow execution might be very large, the result returned might be split up across a number of pages. To retrieve subsequent pages, make additional calls to `PollForDecisionTask` using the `nextPageToken` returned by the initial call. Note that you do not call `GetWorkflowExecutionHistory` with this `nextPageToken`. Instead, call `PollForDecisionTask` again.</important>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the `taskList.name` parameter by using a Condition element with the `swf:taskList.name` key to allow the action to access only certain task lists.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `pollForDecisionTaskAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the PollForDecisionTask operation returned by the service.

#### pollForDecisionTaskAsync

    public Future<DecisionTask> pollForDecisionTaskAsync(PollForDecisionTaskRequest request,
                                                         AsyncHandler<PollForDecisionTaskRequest,DecisionTask> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by deciders to get a DecisionTask from the specified decision `taskList`. A decision task may be returned for any open workflow execution that is using the specified task list. The task includes a paginated view of the history of the workflow execution. The decider should use the workflow type and the history to determine how to properly handle the task.

This action initiates a long poll, where the service holds the HTTP connection open and responds as soon a task becomes available. If no decision task is available in the specified task list before the timeout of 60 seconds expires, an empty result is returned. An empty result, in this context, means that a DecisionTask is returned, but that the value of `taskToken` is an empty string.

<important>Deciders should set their client-side socket timeout to at least 70 seconds (10 seconds higher than the timeout).</important> <important>Because the number of workflow history events for a single workflow execution might be very large, the result returned might be split up across a number of pages. To retrieve subsequent pages, make additional calls to `PollForDecisionTask` using the `nextPageToken` returned by the initial call. Note that you do not call `GetWorkflowExecutionHistory` with this `nextPageToken`. Instead, call `PollForDecisionTask` again.</important>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the `taskList.name` parameter by using a Condition element with the `swf:taskList.name` key to allow the action to access only certain task lists.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `pollForDecisionTaskAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the PollForDecisionTask operation returned by the service.

#### recordActivityTaskHeartbeatAsync

    public Future<ActivityTaskStatus> recordActivityTaskHeartbeatAsync(RecordActivityTaskHeartbeatRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by activity workers to report to the service that the ActivityTask represented by the specified `taskToken` is still making progress. The worker can also (optionally) specify details of the progress, for example percent complete, using the `details` parameter. This action can also be used by the worker as a mechanism to check if cancellation is being requested for the activity task. If a cancellation is being attempted for the specified task, then the boolean `cancelRequested` flag returned by the service is set to `true`.

This action resets the `taskHeartbeatTimeout` clock. The `taskHeartbeatTimeout` is specified in RegisterActivityType.

This action does not in itself create an event in the workflow execution history. However, if the task times out, the workflow execution history will contain a `ActivityTaskTimedOut` event that contains the information from the last heartbeat generated by the activity worker.

<note>The `taskStartToCloseTimeout` of an activity type is the maximum duration of an activity task, regardless of the number of RecordActivityTaskHeartbeat requests received. The `taskStartToCloseTimeout` is also specified in RegisterActivityType.</note> <note>This operation is only useful for long-lived activities to report liveliness of the task and to determine if a cancellation is being attempted. </note> <important>If the `cancelRequested` flag returns `true`, a cancellation is being attempted. If the worker can cancel the activity, it should respond with RespondActivityTaskCanceled. Otherwise, it should ignore the cancellation request.</important>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `recordActivityTaskHeartbeatAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the RecordActivityTaskHeartbeat operation returned by the service.

#### recordActivityTaskHeartbeatAsync

    public Future<ActivityTaskStatus> recordActivityTaskHeartbeatAsync(RecordActivityTaskHeartbeatRequest request,
                                                                       AsyncHandler<RecordActivityTaskHeartbeatRequest,ActivityTaskStatus> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by activity workers to report to the service that the ActivityTask represented by the specified `taskToken` is still making progress. The worker can also (optionally) specify details of the progress, for example percent complete, using the `details` parameter. This action can also be used by the worker as a mechanism to check if cancellation is being requested for the activity task. If a cancellation is being attempted for the specified task, then the boolean `cancelRequested` flag returned by the service is set to `true`.

This action resets the `taskHeartbeatTimeout` clock. The `taskHeartbeatTimeout` is specified in RegisterActivityType.

This action does not in itself create an event in the workflow execution history. However, if the task times out, the workflow execution history will contain a `ActivityTaskTimedOut` event that contains the information from the last heartbeat generated by the activity worker.

<note>The `taskStartToCloseTimeout` of an activity type is the maximum duration of an activity task, regardless of the number of RecordActivityTaskHeartbeat requests received. The `taskStartToCloseTimeout` is also specified in RegisterActivityType.</note> <note>This operation is only useful for long-lived activities to report liveliness of the task and to determine if a cancellation is being attempted. </note> <important>If the `cancelRequested` flag returns `true`, a cancellation is being attempted. If the worker can cancel the activity, it should respond with RespondActivityTaskCanceled. Otherwise, it should ignore the cancellation request.</important>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `recordActivityTaskHeartbeatAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the RecordActivityTaskHeartbeat operation returned by the service.

#### registerActivityTypeAsync

    public Future<Void> registerActivityTypeAsync(RegisterActivityTypeRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Registers a new activity type along with its configuration settings in the specified domain.

<important>A `TypeAlreadyExists` fault is returned if the type already exists in the domain. You cannot change any configuration settings of the type after its registration, and it must be registered as a new version.</important>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `defaultTaskList.name`: String constraint. The key is `swf:defaultTaskList.name`.
  - `name`: String constraint. The key is `swf:name`.
  - `version`: String constraint. The key is `swf:version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `registerActivityTypeAsync` in interface `AmazonSimpleWorkflowAsync`

#### registerActivityTypeAsync

    public Future<Void> registerActivityTypeAsync(RegisterActivityTypeRequest request,
                                                  AsyncHandler<RegisterActivityTypeRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Registers a new activity type along with its configuration settings in the specified domain.

<important>A `TypeAlreadyExists` fault is returned if the type already exists in the domain. You cannot change any configuration settings of the type after its registration, and it must be registered as a new version.</important>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `defaultTaskList.name`: String constraint. The key is `swf:defaultTaskList.name`.
  - `name`: String constraint. The key is `swf:name`.
  - `version`: String constraint. The key is `swf:version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `registerActivityTypeAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### registerDomainAsync

    public Future<Void> registerDomainAsync(RegisterDomainRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Registers a new domain.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- You cannot use an IAM policy to control domain access for this action. The name of the domain being registered is available as the resource of this action.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `registerDomainAsync` in interface `AmazonSimpleWorkflowAsync`

#### registerDomainAsync

    public Future<Void> registerDomainAsync(RegisterDomainRequest request,
                                            AsyncHandler<RegisterDomainRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Registers a new domain.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- You cannot use an IAM policy to control domain access for this action. The name of the domain being registered is available as the resource of this action.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `registerDomainAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### registerWorkflowTypeAsync

    public Future<Void> registerWorkflowTypeAsync(RegisterWorkflowTypeRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Registers a new workflow type and its configuration settings in the specified domain.

The retention period for the workflow history is set by the RegisterDomain action.

<important>If the type already exists, then a `TypeAlreadyExists` fault is returned. You cannot change the configuration settings of a workflow type once it is registered and it must be registered as a new version.</important>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `defaultTaskList.name`: String constraint. The key is `swf:defaultTaskList.name`.
  - `name`: String constraint. The key is `swf:name`.
  - `version`: String constraint. The key is `swf:version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `registerWorkflowTypeAsync` in interface `AmazonSimpleWorkflowAsync`

#### registerWorkflowTypeAsync

    public Future<Void> registerWorkflowTypeAsync(RegisterWorkflowTypeRequest request,
                                                  AsyncHandler<RegisterWorkflowTypeRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Registers a new workflow type and its configuration settings in the specified domain.

The retention period for the workflow history is set by the RegisterDomain action.

<important>If the type already exists, then a `TypeAlreadyExists` fault is returned. You cannot change the configuration settings of a workflow type once it is registered and it must be registered as a new version.</important>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `defaultTaskList.name`: String constraint. The key is `swf:defaultTaskList.name`.
  - `name`: String constraint. The key is `swf:name`.
  - `version`: String constraint. The key is `swf:version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `registerWorkflowTypeAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### requestCancelWorkflowExecutionAsync

    public Future<Void> requestCancelWorkflowExecutionAsync(RequestCancelWorkflowExecutionRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Records a `WorkflowExecutionCancelRequested` event in the currently running workflow execution identified by the given domain, workflowId, and runId. This logically requests the cancellation of the workflow execution as a whole. It is up to the decider to take appropriate actions when it receives an execution history with this event.

<note>If the runId is not specified, the `WorkflowExecutionCancelRequested` event is recorded in the history of the current open workflow execution with the specified workflowId in the domain.</note> <note>Because this action allows the workflow to properly clean up and gracefully close, it should be used instead of TerminateWorkflowExecution when possible.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `requestCancelWorkflowExecutionAsync` in interface `AmazonSimpleWorkflowAsync`

#### requestCancelWorkflowExecutionAsync

    public Future<Void> requestCancelWorkflowExecutionAsync(RequestCancelWorkflowExecutionRequest request,
                                                            AsyncHandler<RequestCancelWorkflowExecutionRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Records a `WorkflowExecutionCancelRequested` event in the currently running workflow execution identified by the given domain, workflowId, and runId. This logically requests the cancellation of the workflow execution as a whole. It is up to the decider to take appropriate actions when it receives an execution history with this event.

<note>If the runId is not specified, the `WorkflowExecutionCancelRequested` event is recorded in the history of the current open workflow execution with the specified workflowId in the domain.</note> <note>Because this action allows the workflow to properly clean up and gracefully close, it should be used instead of TerminateWorkflowExecution when possible.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `requestCancelWorkflowExecutionAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### respondActivityTaskCanceledAsync

    public Future<Void> respondActivityTaskCanceledAsync(RespondActivityTaskCanceledRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by workers to tell the service that the ActivityTask identified by the `taskToken` was successfully canceled. Additional `details` can be optionally provided using the `details` argument.

These `details` (if provided) appear in the `ActivityTaskCanceled` event added to the workflow history.

<important>Only use this operation if the `canceled` flag of a RecordActivityTaskHeartbeat request returns `true` and if the activity can be safely undone or abandoned.</important>

A task is considered open from the time that it is scheduled until it is closed. Therefore a task is reported as open while a worker is processing it. A task is closed after it has been specified in a call to RespondActivityTaskCompleted, RespondActivityTaskCanceled, RespondActivityTaskFailed, or the task has timed out.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `respondActivityTaskCanceledAsync` in interface `AmazonSimpleWorkflowAsync`

#### respondActivityTaskCanceledAsync

    public Future<Void> respondActivityTaskCanceledAsync(RespondActivityTaskCanceledRequest request,
                                                         AsyncHandler<RespondActivityTaskCanceledRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by workers to tell the service that the ActivityTask identified by the `taskToken` was successfully canceled. Additional `details` can be optionally provided using the `details` argument.

These `details` (if provided) appear in the `ActivityTaskCanceled` event added to the workflow history.

<important>Only use this operation if the `canceled` flag of a RecordActivityTaskHeartbeat request returns `true` and if the activity can be safely undone or abandoned.</important>

A task is considered open from the time that it is scheduled until it is closed. Therefore a task is reported as open while a worker is processing it. A task is closed after it has been specified in a call to RespondActivityTaskCompleted, RespondActivityTaskCanceled, RespondActivityTaskFailed, or the task has timed out.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `respondActivityTaskCanceledAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### respondActivityTaskCompletedAsync

    public Future<Void> respondActivityTaskCompletedAsync(RespondActivityTaskCompletedRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by workers to tell the service that the ActivityTask identified by the `taskToken` completed successfully with a `result` (if provided). The `result` appears in the `ActivityTaskCompleted` event in the workflow history.

<important> If the requested task does not complete successfully, use RespondActivityTaskFailed instead. If the worker finds that the task is canceled through the `canceled` flag returned by RecordActivityTaskHeartbeat, it should cancel the task, clean up and then call RespondActivityTaskCanceled.</important>

A task is considered open from the time that it is scheduled until it is closed. Therefore a task is reported as open while a worker is processing it. A task is closed after it has been specified in a call to RespondActivityTaskCompleted, RespondActivityTaskCanceled, RespondActivityTaskFailed, or the task has timed out.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `respondActivityTaskCompletedAsync` in interface `AmazonSimpleWorkflowAsync`

#### respondActivityTaskCompletedAsync

    public Future<Void> respondActivityTaskCompletedAsync(RespondActivityTaskCompletedRequest request,
                                                          AsyncHandler<RespondActivityTaskCompletedRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by workers to tell the service that the ActivityTask identified by the `taskToken` completed successfully with a `result` (if provided). The `result` appears in the `ActivityTaskCompleted` event in the workflow history.

<important> If the requested task does not complete successfully, use RespondActivityTaskFailed instead. If the worker finds that the task is canceled through the `canceled` flag returned by RecordActivityTaskHeartbeat, it should cancel the task, clean up and then call RespondActivityTaskCanceled.</important>

A task is considered open from the time that it is scheduled until it is closed. Therefore a task is reported as open while a worker is processing it. A task is closed after it has been specified in a call to RespondActivityTaskCompleted, RespondActivityTaskCanceled, RespondActivityTaskFailed, or the task has timed out.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `respondActivityTaskCompletedAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### respondActivityTaskFailedAsync

    public Future<Void> respondActivityTaskFailedAsync(RespondActivityTaskFailedRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by workers to tell the service that the ActivityTask identified by the `taskToken` has failed with `reason` (if specified). The `reason` and `details` appear in the `ActivityTaskFailed` event added to the workflow history.

A task is considered open from the time that it is scheduled until it is closed. Therefore a task is reported as open while a worker is processing it. A task is closed after it has been specified in a call to RespondActivityTaskCompleted, RespondActivityTaskCanceled, RespondActivityTaskFailed, or the task has timed out.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `respondActivityTaskFailedAsync` in interface `AmazonSimpleWorkflowAsync`

#### respondActivityTaskFailedAsync

    public Future<Void> respondActivityTaskFailedAsync(RespondActivityTaskFailedRequest request,
                                                       AsyncHandler<RespondActivityTaskFailedRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by workers to tell the service that the ActivityTask identified by the `taskToken` has failed with `reason` (if specified). The `reason` and `details` appear in the `ActivityTaskFailed` event added to the workflow history.

A task is considered open from the time that it is scheduled until it is closed. Therefore a task is reported as open while a worker is processing it. A task is closed after it has been specified in a call to RespondActivityTaskCompleted, RespondActivityTaskCanceled, RespondActivityTaskFailed, or the task has timed out.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `respondActivityTaskFailedAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### respondDecisionTaskCompletedAsync

    public Future<Void> respondDecisionTaskCompletedAsync(RespondDecisionTaskCompletedRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by deciders to tell the service that the DecisionTask identified by the `taskToken` has successfully completed. The `decisions` argument specifies the list of decisions made while processing the task.

A `DecisionTaskCompleted` event is added to the workflow history. The `executionContext` specified is attached to the event in the workflow execution history.

Access Control

If an IAM policy grants permission to use `RespondDecisionTaskCompleted`, it can express permissions for the list of decisions in the `decisions` parameter. Each of the decisions has one or more parameters, much like a regular API call. To allow for policies to be as readable as possible, you can express permissions on decisions as if they were actual API calls, including applying conditions to some parameters. For more information, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `respondDecisionTaskCompletedAsync` in interface `AmazonSimpleWorkflowAsync`

#### respondDecisionTaskCompletedAsync

    public Future<Void> respondDecisionTaskCompletedAsync(RespondDecisionTaskCompletedRequest request,
                                                          AsyncHandler<RespondDecisionTaskCompletedRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Used by deciders to tell the service that the DecisionTask identified by the `taskToken` has successfully completed. The `decisions` argument specifies the list of decisions made while processing the task.

A `DecisionTaskCompleted` event is added to the workflow history. The `executionContext` specified is attached to the event in the workflow execution history.

Access Control

If an IAM policy grants permission to use `RespondDecisionTaskCompleted`, it can express permissions for the list of decisions in the `decisions` parameter. Each of the decisions has one or more parameters, much like a regular API call. To allow for policies to be as readable as possible, you can express permissions on decisions as if they were actual API calls, including applying conditions to some parameters. For more information, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `respondDecisionTaskCompletedAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### signalWorkflowExecutionAsync

    public Future<Void> signalWorkflowExecutionAsync(SignalWorkflowExecutionRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Records a `WorkflowExecutionSignaled` event in the workflow execution history and creates a decision task for the workflow execution identified by the given domain, workflowId and runId. The event is recorded with the specified user defined signalName and input (if provided).

<note> If a runId is not specified, then the `WorkflowExecutionSignaled` event is recorded in the history of the current open workflow with the matching workflowId in the domain.</note> <note> If the specified workflow execution is not open, this method fails with `UnknownResource`.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `signalWorkflowExecutionAsync` in interface `AmazonSimpleWorkflowAsync`

#### signalWorkflowExecutionAsync

    public Future<Void> signalWorkflowExecutionAsync(SignalWorkflowExecutionRequest request,
                                                     AsyncHandler<SignalWorkflowExecutionRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Records a `WorkflowExecutionSignaled` event in the workflow execution history and creates a decision task for the workflow execution identified by the given domain, workflowId and runId. The event is recorded with the specified user defined signalName and input (if provided).

<note> If a runId is not specified, then the `WorkflowExecutionSignaled` event is recorded in the history of the current open workflow with the matching workflowId in the domain.</note> <note> If the specified workflow execution is not open, this method fails with `UnknownResource`.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `signalWorkflowExecutionAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.

#### startWorkflowExecutionAsync

    public Future<Run> startWorkflowExecutionAsync(StartWorkflowExecutionRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Starts an execution of the workflow type in the specified domain using the provided `workflowId` and input data.

This action returns the newly started workflow execution.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `tagList.member.0`: The key is `swf:tagList.member.0`.
  - `tagList.member.1`: The key is `swf:tagList.member.1`.
  - `tagList.member.2`: The key is `swf:tagList.member.2`.
  - `tagList.member.3`: The key is `swf:tagList.member.3`.
  - `tagList.member.4`: The key is `swf:tagList.member.4`.
  - `taskList`: String constraint. The key is `swf:taskList.name`.
  - `workflowType.name`: String constraint. The key is `swf:workflowType.name`.
  - `workflowType.version`: String constraint. The key is `swf:workflowType.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `startWorkflowExecutionAsync` in interface `AmazonSimpleWorkflowAsync`
Returns:
  A Java Future containing the result of the StartWorkflowExecution operation returned by the service.

#### startWorkflowExecutionAsync

    public Future<Run> startWorkflowExecutionAsync(StartWorkflowExecutionRequest request,
                                                   AsyncHandler<StartWorkflowExecutionRequest,Run> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Starts an execution of the workflow type in the specified domain using the provided `workflowId` and input data.

This action returns the newly started workflow execution.

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- Constrain the following parameters by using a `Condition` element with the appropriate keys.
  - `tagList.member.0`: The key is `swf:tagList.member.0`.
  - `tagList.member.1`: The key is `swf:tagList.member.1`.
  - `tagList.member.2`: The key is `swf:tagList.member.2`.
  - `tagList.member.3`: The key is `swf:tagList.member.3`.
  - `tagList.member.4`: The key is `swf:tagList.member.4`.
  - `taskList`: String constraint. The key is `swf:taskList.name`.
  - `workflowType.name`: String constraint. The key is `swf:workflowType.name`.
  - `workflowType.version`: String constraint. The key is `swf:workflowType.version`.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `startWorkflowExecutionAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the StartWorkflowExecution operation returned by the service.

#### terminateWorkflowExecutionAsync

    public Future<Void> terminateWorkflowExecutionAsync(TerminateWorkflowExecutionRequest request)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Records a `WorkflowExecutionTerminated` event and forces closure of the workflow execution identified by the given domain, runId, and workflowId. The child policy, registered with the workflow type or specified when starting this execution, is applied to any open child workflow executions of this workflow execution.

<important> If the identified workflow execution was in progress, it is terminated immediately.</important> <note> If a runId is not specified, then the `WorkflowExecutionTerminated` event is recorded in the history of the current open workflow with the matching workflowId in the domain.</note> <note> You should consider using RequestCancelWorkflowExecution action instead because it allows the workflow to gracefully close while TerminateWorkflowExecution does not.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `terminateWorkflowExecutionAsync` in interface `AmazonSimpleWorkflowAsync`

#### terminateWorkflowExecutionAsync

    public Future<Void> terminateWorkflowExecutionAsync(TerminateWorkflowExecutionRequest request,
                                                        AsyncHandler<TerminateWorkflowExecutionRequest,Void> asyncHandler)

Description copied from interface: `AmazonSimpleWorkflowAsync`

Records a `WorkflowExecutionTerminated` event and forces closure of the workflow execution identified by the given domain, runId, and workflowId. The child policy, registered with the workflow type or specified when starting this execution, is applied to any open child workflow executions of this workflow execution.

<important> If the identified workflow execution was in progress, it is terminated immediately.</important> <note> If a runId is not specified, then the `WorkflowExecutionTerminated` event is recorded in the history of the current open workflow with the matching workflowId in the domain.</note> <note> You should consider using RequestCancelWorkflowExecution action instead because it allows the workflow to gracefully close while TerminateWorkflowExecution does not.</note>

Access Control

You can use IAM policies to control this action's access to Amazon SWF resources as follows:

- Use a `Resource` element with the domain name to limit the action to only specified domains.
- Use an `Action` element to allow or deny permission to call this action.
- You cannot use an IAM policy to constrain this action's parameters.

If the caller does not have sufficient permissions to invoke the action, or the parameter values fall outside the specified constraints, the action fails. The associated event attribute's cause parameter will be set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Specified by:
  `terminateWorkflowExecutionAsync` in interface `AmazonSimpleWorkflowAsync`
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.